<h2>stock1.cfm</h2>

<p>This page shows an example of a single web service request to retrieve a stock quote.</p>

<p>Turn on Debug Output and note the page execution time (normally around 400ms).</p>

<cfset Variables.ko = GetStockQuote("KO")>

<cfoutput>
<table border>
<th>Company</th>
<th>Stock Price</th>
<th>Quote Time</th>
<tr>
	<td>Coca-Cola</td>
	<td>#Variables.ko.Price#</td>
	<td>#Variables.ko.Time#</td>
</tr>
</table>
</cfoutput>

<cffunction name="GetStockQuote" returntype="struct" output="false">
	<cfargument name="tickerSymbol" type="string" required="true">
	
	<cfset var structQuote = StructNew()>

	<cftry>
		<cfinvoke webservice="http://www.webservicex.net/stockquote.asmx?WSDL"
			method="GetQuote" symbol="#Arguments.tickerSymbol#"
			returnvariable="strQuoteXML" timeout="2">
		
		<cfset var objQuote = xmlParse( strQuoteXML )>
		
		<cfset structQuote.price = objQuote.StockQuotes.Stock.Last.XMLText>
		<cfset structQuote.time = objQuote.StockQuotes.Stock.Time.XMLText>
		
		<cfcatch>
			<cfset structQuote.price = "ERROR!">
			<cfset structQuote.time = "ERROR!">
		</cfcatch>
	</cftry>
	
	<cfreturn structQuote>
</cffunction>