<h2>stock2.cfm</h2>

<p>This page shows an example of a four web service requests to retrieve four stock quotes.</p>

<p>Turn on Debug Output and note the page execution time, which should be about 4 times as
long as stock1.cfm (normally around 1600ms).</p>

<cfset Variables.ko = GetStockQuote("KO")>
<cfset Variables.beas = GetStockQuote("BEAS")>
<cfset Variables.msft = GetStockQuote("MSFT")>
<cfset Variables.rhat = GetStockQuote("RHAT")>

<cfoutput>
<table border>
<th>Company</th>
<th>Stock Price</th>
<th>Quote Time</th>
<tr>
	<td>Coca-Cola</td>
	<td>#Variables.ko.Price#</td>
	<td>#Variables.ko.Time#</td>
</tr>
<tr>
	<td>BEA</td>
	<td>#Variables.beas.Price#</td>
	<td>#Variables.beas.Time#</td>
</tr>
<tr>
	<td>Microsoft</td>
	<td>#Variables.msft.Price#</td>
	<td>#Variables.msft.Time#</td>
</tr>
<tr>
	<td>Red Hat</td>
	<td>#Variables.rhat.Price#</td>
	<td>#Variables.rhat.Time#</td>
</tr>
</table>
</cfoutput>

<cffunction name="GetStockQuote" returntype="struct" output="false">
	<cfargument name="tickerSymbol" type="string" required="true">
	
	<cfset var structQuote = StructNew()>

	<cftry>
		<cfinvoke webservice="http://www.webservicex.net/stockquote.asmx?WSDL"
			method="GetQuote" symbol="#Arguments.tickerSymbol#"
			returnvariable="strQuoteXML" timeout="2">
		
		<cfset var objQuote = xmlParse( strQuoteXML )>
		
		<cfset structQuote.price = objQuote.StockQuotes.Stock.Last.XMLText>
		<cfset structQuote.time = objQuote.StockQuotes.Stock.Time.XMLText>
		
		<cfcatch>
			<cfset structQuote.price = "ERROR!">
			<cfset structQuote.time = "ERROR!">
		</cfcatch>
	</cftry>
	
	<cfreturn structQuote>
</cffunction>