<cfcomponent>
	
	<cfset this.name="DirectoryWatcher">
	
	<cffunction name="onApplicationStart">
		<cfset startDirectoryWatcher()>
	</cffunction>
	
	<cffunction name="onRequestStart">
		<cfif NOT isDirectoryWatcherRunning()>
			<cfset startDirectoryWatcher()>
		</cfif>
	</cffunction>
	
	<cffunction name="startDirectoryWatcher">
		<!--- check at 10-second intervals (default interval is 60 seconds) --->
		<cfset directoryWatcher = createObject( "component", "DirectoryWatcher" ).init( 10 )>
		
		<!--- ImageListener implements the DirectoryListener interface --->
		<cfset imageListener = createObject( "component", "ImageListener" )>
		
		<!--- watch the "images" sub-directory of the current directory --->
		<cfset imageDir = getDirectoryFromPath( getCurrentTemplatePath() ) & "images\">
		<cfset directoryWatcher.addListener( imageDir, imageListener )>
		
		<!---
			A single ImageListener instance may watch multiple directories. For example,
			if in addition to the "images" sub-directory we also wanted to watch
			"C:\temp\images", we could simply add the following statement:
			
		<cfset directoryWatcher.addListener( "C:\temp\images", imageListener )>
		--->
	</cffunction>
	
	<cffunction name="isDirectoryWatcherRunning" returntype="boolean">
		<cfset var threadRunning = False>
		<cfset var threads = getAllThreads()>
		<cfset var loopIndex = 0>
		<cfset var returnString = "">
		
		<cfloop from="1" to="#arrayLen(threads)#" index="loopIndex">
			<cfif (threads[loopIndex].name EQ "DirectoryWatcher") AND threadIsAlive(threads[loopIndex])>
				<cfset threadRunning = true>
			</cfif>
		</cfloop>
		
		 <cfreturn threadRunning>
	</cffunction>
</cfcomponent>